/*
 * GraphLCD driver library
 *
 * dbox.h  -  stream2dbox
 *
 * This file is released under the GNU General Public License. Refer
 * to the COPYING file distributed with this package.
 *
 * (c) 2004 Stephan Skrodzki 
 */

#ifndef _GLCDDRIVERS_DBOX_H_
#define _GLCDDRIVERS_DBOX_H_

#include "driver.h"

#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

namespace GLCD
{

class cDriverConfig;

class cDriverDbox : public cDriver
{
private:
	unsigned char ** LCD;
	cDriverConfig * config;
	cDriverConfig * oldConfig;
	char *offbuff;
	long int screensize;
	int CheckSetup();
	void SetPixel(int x, int y);
	
	int port;
	
	int sock_server;
	int sock_dbox;
	struct sockaddr_in serv_addr;

public:
	cDriverDbox(cDriverConfig * config);
	virtual ~cDriverDbox();

	virtual int Init();
	virtual int DeInit();

	virtual void Clear();
	virtual void Set8Pixels(int x, int y, unsigned char data);
	virtual void Refresh(bool refreshAll = false);
};

} // end of namespace

#endif
